#include <cstdio>
#include <cctype>
#include <queue>

#define VELMIVELA 2000000

using namespace std;

typedef struct stav {
	int a,b;
	int kluce;
	int krokov;
} STAV;

inline bool testkey(int &i, char &c) {
	c=tolower(c);
	switch (c) {
		case 'g' : return i/8!=0;
		case 'r' : return (i%8)/4!=0;
		case 'y' : return (i%4)/2!=0;
		case 'b' : return (i%2)!=0;
		default : return false;
	}
}

inline int addkey(int &code,char &key) {
	switch (key) {
		case 'g' : if (!testkey(code,key)) return code+8;
				break;
		case 'r' : if (!testkey(code,key)) return code+4;
				break;
		case 'y' : if (!testkey(code,key)) return code+2;
				break;
		case 'b' : if (!testkey(code,key))  return code+1;
				break;
	}
	return code;
}

int kroky[102][102][16];
char mapa[102][102];
int R,C;

int istx[10000],isty[10000],istkod[10000];
int kist=1;
queue <STAV> front;

void chod(int x, int y, int kod, int krokov) {
	char c=mapa[x][y];

	if (c=='B' || c=='Y' || c=='R' || c=='G') if (!testkey(kod,c)) return;
	if (c=='b' || c=='y' || c=='r' || c=='g') {
		kod=addkey(kod,c);
	}
	if (kroky[x][y][kod]>krokov) {
		kroky[x][y][kod]=krokov;
		krokov++;
		if (x+1<C && mapa[x+1][y]!='#') {
			STAV tmp={x+1,y,kod,krokov}; 
			front.push(tmp);
		}	
		if (x-1>=0 && mapa[x-1][y]!='#') {
			STAV tmp={x-1,y,kod,krokov}; 
			front.push(tmp);
		}	
		if (y+1<R && mapa[x][y+1]!='#') {
			STAV tmp={x,y+1,kod,krokov}; 
			front.push(tmp);
		}	
		if (y-1>=0 && mapa[x][y-1]!='#') {
			STAV tmp={x,y-1,kod,krokov}; 
			front.push(tmp);
		}	
	}
	
}

int main() {

	while (true) {
		int startx,starty;

		scanf("%d %d",&R,&C);
		if (R==0 && C==0) return 0;
		
		getchar();
		for (int i=0;i<R;i++) {
			for (int j=0;j<C;j++) {
				mapa[j][i]=getchar();
				if (mapa[j][i]=='*') {
					startx=j;
					starty=i;
				}
				for (int cod=0;cod<16;cod++) kroky[j][i][cod]=VELMIVELA;
			}
			getchar();
		}

				
		STAV tmp={startx,starty,0,0};
		front.push(tmp);

		while (!front.empty()) {
			tmp=front.front();
			front.pop();
			chod(tmp.a,tmp.b,tmp.kluce,tmp.krokov);
		}


		int najm=VELMIVELA;
		for (int i=0;i<R;i++) {
			for (int j=0;j<C;j++) {
				if (mapa[j][i]=='X') {
					for (int z=0;z<16;z++) if (kroky[j][i][z]<najm) najm=kroky[j][i][z];

				}

			}

		}

		if (najm<VELMIVELA) printf("Escape possible in %d steps.\n",najm); 
		else printf("The poor student is trapped!\n");


	}

	return 0;
}
